#include <iostream>
#include <cmath>
#include <map>
#include <algorithm>
#include <vector>
#include <set>
#include <string>

using namespace std;
vector<int> h;
vector<long long> c;

long long rec(int l, int r)
{
    if(r - l == 0)
    {
        return c[l];
    }
    int max = h[l], maxz = l;
    for(int i = l + 1; i <= r; i++)
    {
        if(h[i] > max)
        {
            max = h[i];
            maxz = i;
        }
    }
    if(maxz == l)
    {
        return c[l];
    }
    if(maxz == r )
    {
        return c[r];
    }
    return c[maxz] + min(rec(l, maxz - 1), rec(maxz + 1, r ));
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    h.resize(n);
    c.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    for(int i = 0; i < n; i++)
    {
        cin >> c[i];
    }
    cout << rec(0, n - 1);
}
