#include <bits/stdc++.h>

using namespace std;
#define int long long

const int MAXN=2e5+100;
int t[4*MAXN] ;

vector<int> a;
int n;
int f(int x, int y) {
    if(x<0) return y;
    if(y<0) return x;
    if(x>= n) return y;
    if(y >= n) return x;
    if (a[x]>a[y]) {
        return x;
    }
    return y;
}

void build(int x, int xl, int xr, vector<int> &a) {
    if (xl+1==xr) {
        t[x]=xl;
        return;
    }
    int xm=(xl+xr)/2;
    build(2*x+1, xl, xm, a);
    build(2*x+2, xm, xr, a);
    t[x]=f(t[2*x+1], t[2*x+2]);
}

int get(int x, int xl, int xr, int ql, int qr) {
    if (qr<=xl or xr<=ql) {
        return -1;
    }
    if (ql<=xl and xr<=qr) {
        return t[x];
    }
    int xm=(xl+xr)/2;
    return f(get(2*x+1, xl, xm, ql, qr), get(2*x+2, xm, xr, ql, qr));
}

int rec(int i, int j, vector<int>& c){
    if(j - i < 1){
        while(true){}
    }

    if(j-i==1){
        return c[i];
    }
    int nowi = get(0,0,n,i,j);
    if(nowi == i){
        return c[i];
    }
    if(nowi == j-1){
        return c[j-1];
    }
    return c[nowi] + min(rec(i,nowi,c),rec(nowi+1,j,c));
}
void solve() {

    cin>>n;
    a.resize(n,0);
    for (int i=0; i<n; ++i) {
        cin>>a[i];
    }
    build(0, 0, n, a);
    vector<int> c(n);
    for(int i = 0; i < n; ++i){
        cin >> c[i];
    }
    cout << rec(0,n+1,c);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();

}