import java.io.IOException;
import java.util.*;

public class Main {

    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);
        int n = Integer.parseInt(s.nextLine());
        String[] split = s.nextLine().split(" ");
        int[] a = new int[n];
        for (int i = 0; i < n; i++) a[i] = Integer.parseInt(split[i]);
        int k = 31 - Integer.numberOfLeadingZeros(n + 1);

        Map<Integer, Integer> map = new HashMap<>();
        for (int i = 0; i < n; i++) map.merge(a[i], 1, Integer::sum);
        List<Map.Entry<Integer, Integer>> list = map.entrySet().stream().sorted(Map.Entry.comparingByKey()).toList();
        Map.Entry<Integer, Integer> min = list.get(0);
        for (Map.Entry<Integer, Integer> e : list) {
            if (e != min && e.getValue() >= min.getValue()) {
                System.out.println("-1");
                return;
            }
        }
        if (min.getValue() != k) {
            System.out.println("-1");
            return;
        }
        int[] arr = new int[k + 1];
        Arrays.fill(arr, 1);
        for (int i = 1; i < list.size(); i++) {
            Map.Entry<Integer, Integer> e = list.get(i);
            if (arr[e.getValue()] == 0) {
                System.out.println("-1");
                return;
            }
            arr[e.getValue()]--;
            for (int j = 1; j < e.getValue(); j++) arr[j]++;
        }
        k--;
        int[] res = new int[(n + 1) / 2];
        list = new ArrayList<>(list);
        list.sort(Map.Entry.comparingByValue());
        Collections.reverse(list);
        int ind = 1;
        res[0] = min.getKey();
        for (int i = 1; i <= k; i++) {
            int ii = 1 << (k - i);
            res[ii] = list.get(ind).getKey();
            ind++;
            for (int j = 1; j < i; j++) {
                ii += (1 << (k - i + j));
                res[ii] = list.get(ind).getKey();
                ind++;
            }
        }
        StringBuilder st = new StringBuilder();
        for (int i = 0; i < res.length; i++) st.append(res[i]).append(" ");
        System.out.println(st);
    }

}