#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define fi first
#define se second
mt19937_64 rnd(chrono::steady_clock().now().time_since_epoch().count());

struct query {
    ll t, d, w, i;
};

bool operator<(query a, query b) {
    return tie(a.d, a.t, a.i) < tie(b.d, b.t, b.i);
}

ld binpow(ld x, int n) {
    ld res = 1;
    ld cur = x;
    while (n) {
        if (n & 1) res *= cur;
        cur *= cur;
        n >>= 1;
    }
    return res;
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, m;
    cin >> n >> m;
    ld r;
    cin >> r;

    vector<query> q;
    for (int i = 0; i < n; i++) {
        int d, w;
        cin >> d >> w;
        q.push_back({-1, d, w, i});
    }

    for (int i = 0; i < m; i++) {
        int d;
        cin >> d;
        q.push_back({1, d, 0, i});
    }

    sort(q.begin(), q.end());
    ld cur = 0;
    ll d = 0;
    vector<ld> ans(m);
    for (int i = 0; i < q.size(); i++) {
        cur = cur * binpow(1 - r, q[i].d - d) + q[i].w * r;
        d = q[i].d;
        if (q[i].t == 1) {
            ans[q[i].i] = cur;
        }
    }
    cout << fixed << setprecision(7);
    for (auto el : ans) cout << el << ' ';

    return 0;
}