#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()

using namespace std;

//#define int ll
#define ss second
#define ff first

vector<pair<char, char>> mov = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
vector<pair<char, char>> mov1 = {{1, 1}, {1, -1}, {-1, 1}, {-1, -1},{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
int n, m;

bool check(int i, int j){
    return (0 <= i) && (i < n) && (0 <= j) && (j < m);
}

bool check2(vector<pair<int, int>> cur1){
    vector<pair<int, int>> cur;
    for(auto x : cur1){
        cur.push_back(x);
    }
    vector<int> deq(4);
    for(int i = 0; i < 3; ++i){
        for(int j = i + 1; j < 4; ++j){
            if((abs(cur[i].first - cur[j].first) + abs(cur[i].second - cur[j].second)) == 1){
                ++deq[i];
                ++deq[j];
            }
        }
    }
    int sum = 0;
    for(auto x : deq){
        sum += x;
        if(x == 0) return false;
    }
    return sum > 4;
}

void solve(){
    cin >> n >> m;
    vector<vector<char>> mp(n, vector<char> (m));
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < m; ++j){
            cin >> mp[i][j];
        }
    }
    map<vector<pair<int, int>>, int> dist;
    dist[{{0, 0}, {0, 1}, {1, 0}, {1, 1}}] = 1;
    queue<vector<pair<int, int>>> q;
    q.push({{0, 0}, {0, 1}, {1, 0}, {1, 1}});
    while(len(q)){
        auto cur = q.front();
        q.pop();
        vector<pair<int, int>> ok;
        for(auto x : cur){
            for(auto dx : mov){
                int nx = x.first + dx.first;
                int ny = x.second + dx.second;
                bool fl = true;
                for(auto t : cur){
                    if(t == make_pair(nx, ny)) fl = false;
                }
                if(check(nx, ny) && fl && mp[nx][ny] == '.'){
                    ok.push_back({nx, ny});
                }
            }
        }
        for(auto x : ok){
            for(auto dx : mov1){
                int nx = x.first + dx.first;
                int ny = x.second + dx.second;
                bool fl = false;
                for(auto t : cur){
                    if(t == make_pair(nx, ny)) fl = true;
                }
                if(check(nx, ny) && mp[nx][ny] == '.' && fl){
                    vector<pair<int, int>> newcur;
                    for(auto t : cur){
                        if(t.first != nx || t.second != ny){
                            newcur.push_back(t);
                        }
                    }
                    newcur.push_back(x);
                    sort(all(newcur));
                    if(check2(newcur) && dist[newcur] == 0){
                        dist[newcur] = dist[cur] + 1;
                        q.push(newcur);
                    }
                }
            }
        }
    }
    cout << dist[{{n - 2, m - 2}, {n - 2, m - 1}, {n - 1, m - 2}, {n - 1, m - 1}}]  - 1<< '\n';
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}