#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>

// K
using namespace std;

int main() {
    cout.precision(16);
    int n, m;
    double r;
    cin >> n >> m;
    cin >> r;
    vector<double> s(n);
    for (int i = 0; i < n; ++i) {
        int d, w;
        cin >> d >> w;
        while (s.size() < d) {
            s.push_back(0);
        }
        s[d-1] = w;
//        cout << 1 << endl;
    }
    vector <int> q(m);
    for (int i = 0; i < m; ++i) {
        cin >> q[i];
    }
    s[0]*=r;
    for (int i = 1; i < s.size(); ++i) {
        s[i] = s[i-1]*(1-r) + s[i]*r;
    }
    for(int i = 0; i < m; ++i) {
        if (q[i] < s.size()) {
            cout << s[q[i]-1] << " ";
        } else {
            int last = s.size()-1;

            double a = max(0.0, (s[last]*pow(r, ceil((double)(q[i]-1 - last)/2)))*pow(1-r, (q[i]-1 - last)/2));
            if (a == 0) cout << 0 << " ";
            else cout << a << " ";
        }
    }
}
