#include<iostream>
#include<algorithm>
#include<set>
#include<string>
#include<vector>
#include<cmath>
#include <map>

using namespace std;

vector<int> vec;
map<int, int> mp;
vector<set<int>> st;
vector<int> c;

void f(int u, int h, int p) {
	//cout << u << " " << h << " " << p << "\n";
	if (st[h].size() == 0 || (h != 1 && st[h - 1].size() == 0)) {
		cout << "-1\n";
		exit(0);
	}
	int find = 0;
	if (p != -1) {
		find = c[p];
	}
	//cout << find << ")\n";
	auto it = st[h].lower_bound(find);
	if (it == st[h].end()) {
		cout << "-1\n";
		exit(0);
	}
	c[u] = *it;
	st[h].erase(it);
	//cout << "left color " << u << " " << c[u] << "\n";
	if (h == 1) {
		return;
	}
	it = st[h - 1].lower_bound(c[u]);
	if (it == st[h - 1].end()) {
		cout << "-1\n";
		exit(0);
	}
	//cout << "right color " << u << " " << (*it) << "\n";
	c[2 * u + 2] = *it;
	st[h - 1].erase(it);
	int v = 2 * u + 1, hh = h - 1;
	while (1) {
		c[v] = c[u];
		if (hh <= 1) {
			break;
		}
		//cout << "l " << u << " " << 2 * v + 2 << "****\n";
		f(2 * v + 2, hh - 1, v);
		v = 2 * v + 1;
		hh--;
	}
	v = 2 * u + 2;
	hh = h - 1;
	while (1) {
		c[v] = c[2 * u + 2];
		if (hh <= 1) {
			break;
		}
		//cout << "r " << u << " " << 2 * v + 1 << "*****\n";
		f(2 * v + 1, hh - 1, v);
		v = 2 * v + 2;
		hh--;
	}
}

int main() {
	int n;
	cin >> n;
	vec.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> vec[i];
	}
	int k = log2(n + 1);
	if ((1 << k) < n + 1) {
		k++;
	}
	if ((1 << k) != n + 1) {
		cout << "-1\n";
		return 0;
	}
	st.resize(k + 1);
	c.resize(2 * n);
	for (int i = 0; i < n; i++) {
		if (mp.find(vec[i]) == mp.end()) {
			mp[vec[i]] = 0;
		}
		mp[vec[i]]++;
	}
	for (auto key : mp) {
		if (key.second > k) {
			cout << "-1\n";
			return 0;
		}
		st[key.second].insert(key.first);
	}
	//cout << k << "!\n";
	f(0, k, -1);
	for (int i = (1 << (k - 1)) - 1; i < n; i++) {
		cout << c[i] << " ";
	}
	cout << "\n";
	return 0;
}