#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>

#define ll long long

using namespace std;

unordered_map <ll, ll> memo;

ll recurs(ll x, ll y){
    if(memo[x*y]!=0){
        return memo[x*y];
    }
    if(x*y == 1){
        return 1;
    }
    if(x > y){
        if(x%2 == 1){
            memo[x*y] = x*y + recurs(x/2, y) + recurs(x/2 +1,y);
            return memo[x*y];
        }
        else if (x%2 == 0)
        {
            memo[x*y] = x*y + 2 * recurs(x/2,y);
            return memo[x*y];
        }
    }
    else{
        if(y%2 == 1){
            memo[x*y] = x*y + recurs(x, y/2) + recurs(x,y/2 +1);
            return memo[x*y];
        }
        else if (y%2 == 0)
        {
            memo[x*y] = x*y + 2 * recurs(x,y/2);
            return memo[x*y];
        }
    }
    return 0;
}

int main() {
    ll x, y;
    cin >> x >> y;
    cout << recurs(x,y);

    return 0;
}