#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

int mod(int x, int m) {
    return (x % m + m) % m;
}

int gcd_ext(int a, int b, int &x, int &y) {
    if (a == 0) {
        x = 0;
        y = 1;
        return b;
    }
    int x1, y1;
    int d = gcd_ext(b % a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return d;
}

void diof() {
    int a, m, x, y;
    cin >> a >> m;
    if (__gcd(a, m) != 1) cout << -1;
    else {
        gcd_ext(a, m, x, y);
        cout << mod(x, m);
    }
}

void lin_sieve() {
    int n = 1e8;
    vector<int> lp(n + 1);
    vector<int> pr;
    for (int i = 2; i <= n; i++) {
        if (lp[i] == 0) {
            lp[i] = i;
            pr.push_back(i);
        }
        for (int j = 0; j < pr.size() && pr[j] <= lp[i] && i * pr[j] <= n; j++)
            lp[i * pr[j]] = pr[j];
    }
    for (int i = 0; i < 100; i++) {
        cout << i << " " << lp[i] << endl;
    }
}

struct trp {
    int x, y, z;

    trp() {
        x = 0, y = 0, z = 0;
    }

    trp(int a, int b, int c) {
        x = a, y = b, z = c;
    }
};

void solve() {
    vector<vector<int>> a(10, vector<int>(10));
    string s;
    for (int i = 0; i < 10; ++i) {
        cin >> s;
        for (int j = 0; j < 10; ++j) {
            if (s[j] == '#') {
                a[i][j] = 1;
            } else {
                a[i][j] = 0;
            }
        }
    }
    for (int i = 0; i < 10; ++i) {
        for (int j = 0; j < 10; ++j) {
            if (a[i][j] == 0) {
                continue;
            }
            int x = i - 1, y = j - 1;
            if (x > -1 && y > -1 && a[x][y] == 1) {
                cout << "NO";
                return;
            }
            x = i + 1;
            if (x < 10 && y > -1 && a[x][y] == 1) {
                cout << "NO";
                return;
            }
            y = j + 1;
            if (x < 10 && y < 10 && a[x][y] == 1) {
                cout << "NO";
                return;
            }
            x = i - 1;
            if (x > -1 && y < 10 && a[x][y] == 1) {
                cout << "NO";
                return;
            }
        }
    }
    vector<trp> v, g;
    int x = -1, y = -1;
    for (int i = 0; i < 10; ++i) {
        for (int j = 0; j < 10; ++j) {
            if (a[i][j] == 1) {
                if (y == -1) {
                    y = j;
                    x = i;
                }
            } else {
                if (y != -1) {
                    g.push_back(trp(x, y, j - 1));
                    if (j - y > 4) {
                        cout << "NO";
                        return;
                    }
                    x = -1;
                    y = -1;
                }
            }
        }
        if (y != -1) {
            g.push_back(trp(x, y, 9));
            if (9 - y > 3) {
                cout << "NO";
                return;
            }
            x = -1;
            y = -1;
        }
    }
    for (int i = 0; i < 10; ++i) {
        for (int j = 0; j < 10; ++j) {
            if (a[j][i] == 1) {
                if (y == -1) {
                    y = j;
                    x = i;
                }
            } else {
                if (y != -1) {
                    v.push_back(trp(y, x, j - 1));
                    if (j - y > 4) {
                        cout << "NO";
                        return;
                    }
                    x = -1;
                    y = -1;
                }
            }
        }
        if (y != -1) {
            v.push_back(trp(y, x, 9));
            if (9 - y > 3) {
                cout << "NO";
                return;
            }
            x = -1;
            y = -1;
        }
    }
    vector<bool> used(g.size()), used2(v.size());
    for (int i = 0; i < g.size(); ++i) {
        for (int j = 0; j < v.size(); ++j) {
            if (used[i] || used2[j]) {
                continue;
            }
            if (v[j].y >= g[i].y && v[j].y <= g[i].z && g[i].x >= v[j].x && g[i].x <= v[j].z) {
//                cout << i << ' ' << j << '\n';
                bool f1 = false, f2 = false;
                if (v[j].x == v[j].z) {
                    used2[j] = false;
                    f1 = true;
                }
                if (g[i].y == g[i].z) {
                    used[i] = true;
                    f2 = true;
                }
                if (f1 && f2) {
                    used[i] = true;
                } else if (f1) {
                    used2[j] = true;
                } else if (f2) {
                    used[i] = true;
                } else {
                    cout << "NO";
                    return;
                }
            }
        }
    }
    vector<int> cnt(5);
    for (int i = 0; i < g.size(); ++i) {
        if (!used[i]) {
            cnt[g[i].z - g[i].y + 1]++;
        }
    }
    for (int i = 0; i < v.size(); ++i) {
        if (!used2[i]) {
            cnt[v[i].z - v[i].x + 1]++;
        }
    }
    /*for (int i = 0; i < v.size(); ++i) {
        cout << v[i].x << ' ' << v[i].y << ' ' << v[i].z << '\n';
    }
    cout << '\n';
    for (int i = 0; i < g.size(); ++i) {
        cout << g[i].x << ' ' << g[i].y << ' ' << g[i].z << '\n';
    }
    cout << '\n';*/
    if (cnt[1] == 4 && cnt[2] == 3 && cnt[3] == 2 && cnt[4] == 1) {
        cout << "YES";
    } else {
        cout << "NO";
    }
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    solve();
}
