#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("03")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,bmi2,fma")


#define int long long
#define double long double


vector<int> c;

struct st{
    vector<int> v;
    vector<vector<pair<int, int>>> d;
    vector<int> lg;

    void init(){
        lg.resize(v.size() + 1);
        lg[1] = 0;
        for(int i = 2; i <= v.size(); i++){
            lg[i] = 1 + lg[i / 2];
        }
        d.resize(v.size(), vector<pair<int, int>>(30));
        for(int i = 0; i < v.size(); i++){
            d[i][0] = {v[i], i};
        }
        for(int j = 1; j < 30; j++) {
            for (int i = 0; i < v.size(); i++) {
                if(i + (1 << (j - 1)) >= v.size()){
                    break;
                }
                d[i][j] = max(d[i][j - 1], d[i + (1 << (j - 1))][j - 1]);
            }
        }
    }
    pair<int, int> get(int l, int r){
        return max(d[l][lg[r - l]], d[r - (1 << lg[r - l])][lg[r - l]]);
    }
};

st spar;

int ans(int l, int r){
    if(r - l == 1){
        return c[l];
    }
    int m = spar.get(l, r).second;
    int x = (int)2e18;
    if(l != m){
        x = min(x, ans(l, m));
    }
    if(m + 1 != r){
        x = min(x, ans(m + 1, r));
    }
    return c[m] + x;
}


signed main() {
#ifdef sjbody
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    spar.v.resize(n);
    c.resize(n);
    for(int i = 0; i < n; i++){
        cin >> spar.v[i];
    }
    for(int i = 0; i < n; i++){
        cin >> c[i];
    }
    spar.init();
    cout << ans(0, n);
    return 0;
}