#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

const ll inf = 1e18;
const ll mod = 1e9 + 7;

ll in = 0;
vector<ll>ans;
map<ll, set<ll>>mp;
void rec(ll n, ll p) {
    if (mp[n].empty()) {
        cout << -1;
        exit(0);
    }
    ans[in] = *mp[n].begin();
    if (ans[in] < p) {
        cout << -1;
        exit(0);
    }
    mp[n].erase(mp[n].begin());
    ++in;
    for (ll i = 1; i < n; ++i) {
        rec(i, ans[in - 1]);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n;
    cin >> n;
    vector<ll> a(n);
    map<ll, ll> cnt;
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
        cnt[a[i]]++;
    }
    for (auto i : cnt) {
        mp[i.second].insert(i.first);
    }
    ll k = 1;
    while ((1 << k) - 1 != n) {
        k++;
    }
    ans.resize(1 << (k - 1));
    rec(k, inf);
    for (ll i : ans) {
        cout << i << ' ';
    }
}