#include <iostream>

typedef long long ll;

const int N = 200000;
int h[N], c[N];

ll solve(int l, int r) {
    if (r - l == 0) {
        return 0LL;
    } else {
        int m = l;
        for (int i = l + 1; i < r; ++i) {
            if (h[i] > h[m]) {
                m = i;
            }
        }
        return c[m] + std::min(solve(l, m), solve(m + 1, r));
    }
}

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    
    int n;
    std::cin >> n;
    for (int i = 0; i < n; ++i) {
        std::cin >> h[i];
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> c[i];
    }

    std::cout << solve(0, n) << "\n";
}