#include "bits/stdc++.h"
#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(NULL);

#define int long long
#define mp make_pair
#define pb push_back
#define endl "\n"

int inf = 100000000000000000L;

struct SegmentTree{
    vector<int> a;
    vector<int> d;

    void buildTree(int v,int l,int r){
        if(r-l==1) {
            d[v] = a[l];
            return;
        }

        int m =(l+r) / 2;

        buildTree(2*v+1,l,m);
        buildTree(2*v+2,m,r);

        d[v] = max(d[2*v+1],d[2*v+2]);
    }

    int findAns(int v,int l,int r,int tl,int tr){
        if(r <= tl || l >= tr){
            return -1;
        }

        if(l >= tl && r <= tr){
            return d[v];
        }

        int m = (l+r) / 2;
        return max(findAns(2*v+1,l,m,tl,tr),findAns(2*v+2,m,r,tl,tr));
    }


};

map<int,int> ob;
vector<int> h,c;
SegmentTree tre;
int n;

int solve(int l,int r){

    int mx = tre.findAns(0,0,n,l,r+1);

    int i = ob[mx];
    int r1 =inf;
    int r2 = inf;

    if(l==r){
        return c[i];
    }

    if(i-1 >= l) r1 = solve(l,i-1);
    else r1 = 0;
    if(i+1 <= r) r2 = solve(i+1,r);
    else r2 = 0;
    return min(r1,r2) + c[i];


}

int32_t main(){
    cout.sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

   // int n;
    cin >> n;

    h = vector<int>(n);
    c = vector<int>(n);


    for(int i=0;i<n;i++){
        cin >> h[i];
        ob[h[i]] = i;
    }

    for(int i=0;i<n;i++){
        cin >> c[i];
    }

    tre.a = h;
    tre.d = vector<int>(4*n);
    tre.buildTree(0,0,n);

   // for(int i=0;i<n;i++){
   //     cout << tre.findAns(0,0,n,0,i+1);
   // }


    cout << solve(0,n-1) << endl;
}
