#ifdef LOCAL
#define _GLIBCXX_DEBUG 1
#define nl endl
#else
#define nl '\n'
#pragma GCC optimize("Ofast")
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define forn(i, n) for(decltype(n) i = 0; i < n; i++)
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define _ <<" "<<
#define pb push_back
#define eb emplace_back
#define ll long long
#define ld long double
#define ull unsigned long long

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    unordered_map<int, int> cnt;
    forn(i, n) cin >> a[i], cnt[a[i]]++;

    sort(all(a));
    set <pair<int, int>> st;
    int k = __lg(n + 1);

    if (cnt[a[0]] != k) {
        cout << -1 << nl;
        return;
    }
    vector<int> ans(1 << (k - 1), -1);
    ans[0] = a[0];
    for (int i = 1; i < k; i++) st.emplace(i, 0);
    a.resize(unique(all(a)) - a.begin());
    for(int i = 1; i < a.size(); i++) {
        auto it = st.lower_bound(make_pair(cnt[a[i]], 0));
        if (it == st.end()) {
            cout << -1 << nl;
            return;
        }
        auto [lvl, pos] = *it;
        st.extract({lvl, pos});
        int npos = pos + (1 << (lvl - 1));
        ans[npos] = a[i];
        for (int j = 1; j < lvl; j++) st.emplace(j, npos);
    }
    for(int x : ans) cout << x << " ";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(15);

    int t = 1;
//    cin >> t;
    while (t--) solve();
}