#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

vector<int> gen() {
    int sz = 1 << (rnd() % 15 + 1);
    vector<int> a;
    a.resize(1 << sz);
    iota(a.begin(), a.end(), 1);
    shuffle(a.begin(), a.end(), rnd);
    return a;
}

vector<int> build(vector<int> &a) {
    int n = a.size();
    vector<int> t;
    t.resize(2 * n);
    for (int i = n;i < (n << 1); i ++) t[i] = a[i - n];
    for (int i = n - 1;i >= 0;i --) t[i] = min(t[i << 1], t[i << 1 | 1]);
    t.erase(t.begin());
    return t;
}

int log(int x) {
    int cnt = 0;
    while (x % 2 == 0) {
        cnt++;
        x /= 2;
    }
    if (x == 1) return cnt;
    return -1;
}

int len;
int h;

void rec(int dady, int deep, int right, vector<set<int>>& dop, vector<int>&a) {
    if (deep > h) return;
    int tecpos = (dady + right) / 2;
    if (dop[deep].empty()) return;
    auto tmp = dop[deep].lower_bound(a[dady]);
    if (tmp == dop[deep].end()) return;
    a[tecpos] = *tmp;
    dop[deep].erase(tmp);

    if (dop[deep].empty()) return;
    tmp = dop[deep].lower_bound(a[len - dady - 1]);
    if (tmp == dop[deep].end()) return;
    a[len - tecpos - 1] = *tmp;
    dop[deep].erase(tmp);
    rec(dady, deep + 1, tecpos, dop, a);
    rec(tecpos, deep + 1, right, dop, a);
}

vector<int> solve(vector<int> b) {
    int n = b.size();
    //int n;
    //cin >> n;
    len = (n + 1) / 2;
    h = log(n + 1);
    //vector<int> b(n);
    map<int, int> cnt;
    vector<int> a;
    cnt.clear();
    for (auto &i: b) {
        cnt[i]++;
    }
    if (n == 1) {
        a.emplace_back(b[0]);
        return a;
    }
    vector<set<int>> dop;
    dop.resize(h + 1);
    for (auto [val, num]: cnt) {
        if (num > h) {
            //cout << -1;
            return {-1};
        }
        dop[h - num].insert(val);
    }
    if (dop[0].empty() || dop[1].empty()) {
        //cout << -1;
        return {-1};
    }
    a.resize(len);
    a[0] = *dop[0].begin();
    dop[0].erase(dop[0].begin());
    a[len - 1] = *dop[1].begin();
    dop[1].erase(dop[1].begin());
    rec(0, 2, len / 2, dop, a);
    for (int i = 0; i < len; i++) {
        if (a[i] == 0) {
            //cout << -1;
            return {-1};
        }
    }
/*    for (int i = 0; i < len; i++) {
        cout << a[i] << " ";
    }*/
    return a;
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector<int> b(n);
    for (auto & i : b) cin >> i;
    vector<int> ans = solve(b);
    for (auto x : ans) cout << x << " ";
/*    int cnt = 0;
    while(true) {
        cout << cnt ++ << endl;
        vector<int> g = gen();
        vector<int> seg1 = build(g);
        shuffle(seg1.begin(), seg1.end(), rnd);
        vector<int> ans = solve(seg1);
        vector<int> seg2 = build(ans);
        sort(seg2.begin(), seg2.end());
        sort(seg1.begin(), seg1.end());
        if (seg1 == seg2) continue;
        for (auto & i : seg1) cout << i << " ";
        cout << endl;
        for (auto & i : seg2) cout << i << " ";
        cout << endl;
        for (auto & i : g) cout << i << " ";*/
/*        break;
    }*/
}


/*bool solve(vector<int> b) {
    int n = b.size();
    //int n;
    //cin >> n;
    len = (n + 1) / 2;
    h = log(n + 1);
    //vector<int> b(n);
    map<int, int> cnt;
    cnt.clear();
    for (auto &i: b) {
        cin >> i;
        cnt[i]++;
    }
    if (n == 1) {
        a.emplace_back(b[0]);
        return true;
    }
    dop.resize(h + 1);
    for (auto [val, num]: cnt) {
        if (num > h) {
            cout << -1;
            return;
        }
        dop[h - num].insert(val);
    }
    if (dop[0].empty() || dop[1].empty()) {
        cout << -1;
        return;
    }
    a.resize(len);
    a[0] = *dop[0].begin();
    dop[0].erase(dop[0].begin());
    a[len - 1] = *dop[1].begin();
    dop[1].erase(dop[1].begin());
    rec(0, 2, len / 2);
    for (int i = 0; i < len; i++) {
        if (b[i] == 0) {
            cout << -1;
            return;
        }
    }
    for (int i = 0; i < len; i++) {
        cout << a[i] << " ";
    }
}
*/