#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

ld binpow(ld x, ll n) {
    if (n == 0) {
        return 1;
    }
    ld y = binpow(x, n / 2);
    if (n % 2 == 0) {
        return y * y;
    } else {
        return y * y * x;
    }
}

vector<vector<int>> st;
vector<ll> h, c;

ll rec(int l, int r) {
    if (l + 1 == r) {
        return c[l];
    }
    if (l == r) {
        return 0;
    }
    int m;
    int k = __lg(r - l);
    int m1 = st[k][l], m2 = st[k][r - (1 << k)];
    if (h[m1] > h[m2]) {
        m = m1;
    } else {
        m = m2;
    }
    return c[m] + min(rec(l, m), rec(m + 1, r));
}

void solve() {
    int n;
    cin >> n;
    h.resize(n);
    c.resize(n);
//    vector<ll> h(n), c(n);
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    st.resize(__lg(n) + 1);
    for (int i = 0; i < __lg(n) + 1; ++i) {
        st[i].resize(n);
    }
    for (int i = 0; i < n; ++i) {
        st[0][i] = i;
    }
    for (int i = 1; i < __lg(n) + 1; ++i) {
        for (int j = 0; j + (1 << i) <= n; ++j) {
            ll mx1 = h[st[i - 1][j]], mx2 = h[st[i - 1][j + (1 << (i - 1))]];
            if (mx1 > mx2) {
                st[i][j] = st[i - 1][j];
            } else {
                st[i][j] = st[i - 1][j + (1 << (i - 1))];
            }
        }
    }
    cout << rec(0, n);
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    solve();
}
