#include <iostream>
#include <bits/stdc++.h>

using namespace std;
vector<vector<bool>> used(10, vector<bool>(10));
vector<vector<int>> col(10, vector<int>(10));
vector<string>a(10);
int sz = 0;
int szs[5];
set<pair<int,int>>moves = {{-1, 0}, {0, -1}, {1, 0}, {0, 1}};
set<pair<int,int>>movesgv = {{-1, 0}, {0, -1}, {1, 0}, {0, 1}, {1, 1}, {-1, -1}};
void dfs(int x, int y, int cl){
    used[x][y] = true;
    sz++;
    col[x][y] = cl;
    if (sz > 4) {
        cout << "NO\n";
        exit(0);
    }
    for (auto &[dx, dy] : moves) {
        int nx = x + dx;
        int ny = y + dy;
        if (ny < 10 && ny >= 0 && nx < 10 && nx >= 0 && !used[nx][ny] && a[nx][ny] == '#'){
            dfs(nx, ny, cl);
        }
    }
}
int main() {
    const int n = 10;
    for(auto &v : a)
        cin >> v;
    int h = 0;
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++) {
            if (!used[i][j] && a[i][j] == '#') {
                sz = 0;
                dfs(i, j, h);
                h++;
                szs[sz]++;
            }
        }
    }
    if (szs[4] == 1 && szs[3] == 2 && szs[2] == 3 && szs[1] == 4){
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {

                if (a[i][j] == '#'){
                    for (auto [dx,dy] : movesgv){
                        if (i + dx >= 0 && i + dx < n && j + dy < n && j + dy >= 0 && a[i + dx][j + dy] == '#'
                        && col[i + dx][j + dy] != col[i][j]){
                            cout << "NO\n";
                            return 0;
                        }
                    }
                }
            }
        }
        cout << "YES\n";
    }
    else {
        cout << "NO\n";
    }
}
