#include <iostream>
#include <vector>
using namespace std;

int abc[12][12];
int use[10][10];
int ships[5];

int search(int i, int y) {
    use[i][y] = 1;
    if (abc[i+1][y-1] == 1 || abc[i+1][y+1] == 1 || abc[i-1][y+1] == 1 || abc[i-1][y-1] == 1) {
        return -1;
    }
    else {
        if (abc[i][y-1] == 1) {
            int a = search(i, y-1);
            if (a == -1) {
                return -1;
            }
            return a+1;
        }
        if (abc[i+1][y] == 1) {
            int a = search(i+1, y);
            if (a == -1) {
                return -1;
            }
            return a+1;
        }
    }
    return 1;
}

int main() {
    for (int i = 0; i < 12; i++) {
        for (int y = 0; y < 12; y++) {
            if (i > 0 && i < 11 && y > 0 && y < 11) {
                char temp; cin >> temp;
                if (temp == '#') {
                    abc[i][y] = 1;
                }
                else {
                    abc[i][y] = 0;
                }
            }
            else {
                abc[i][y] = 0;
            }
        }
    }
    int arr[5]{};
    for (int y = 0; y < 11; y++) {
        for (int i = 1; i < 11; i++) {
            if (abc[i][y] == 1 && use[i-1][y-1] == 0) {
                int a = search(i, y); 
                if (a == -1) {
                    cout << "NO\n";
                    return 0;
                } else arr[a]++;
            } 
        }
    }
    if(arr[1]==4&&arr[2]==3&&arr[3]==2&&arr[4]==1)cout << "YES\n";
    else for(auto c:arr)cout<<c<<" ";
    return 0;
}