#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 42;
char field[MAX_N][MAX_N];
int cnt[MAX_N];

bool check(int x, int y, int dx, int dy, int n, int m) {
    if (x + dx < 0 || x + dx >= n) {
        return false;
    }
    if (y + dy < 0 || y + dy >= m) {
        return false;
    }
    return true;
}

int main() {
    ios_base ::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n = 10, m = 10;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> field[i][j];
        }
    }
    cnt[1] = 4;
    cnt[2] = 3;
    cnt[3] = 2;
    cnt[4] = 1;

    vector<int> dx = {-1, 1, 1, -1};
    vector<int> dy = {1, 1, -1, -1};

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (field[i][j] == '.') {
                continue;
            }
            for (int k = 0; k < 4; k++) {
                if (!check(i, j, dx[k], dy[k], n, m)) {
                    continue;
                }
                if (field[i + dx[k]][j + dy[k]] == '#') {
                    cout << "NO";
                    return 0;
                }
            }
        }
    }

    dx = {0, 1, 0, -1};
    dy = {1, 0, -1, 0};

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (field[i][j] == '.') {
                continue;
            }
            int now = 0;
            int dir = -1;
            for (int k = 0; k < 4; k++) {
                if(!check(i, j, dx[k], dy[k], n, m)){
                    continue;
                }
                if (field[i + dx[k]][j + dy[k]] == '#') {
                    if (now > 0 && abs(dir - k) != 2) {
                        cout << "NO";
                        return 0;
                    }
                    now++;
                    dir = k;
                }
            }
            if (now > 2) {
                cout << "NO";
                return 0;
            }

            if (now > 1) {
                continue;
            }

            if (dir == -1) {
                cnt[1]--;
                continue;
            }

            if (dir >= 2) {
                continue;
            }

            int x = i;
            int y = j;
            int len = 1;
            while (check(x, y, dx[dir], dy[dir], n, m) && field[x + dx[dir]][y + dy[dir]] == '#') {
                x += dx[dir];
                y += dy[dir];
                len++;
            }

            cnt[len]--;
        }
    }
    for (int i = 1; i <= 4; i++) {
        if (cnt[i] != 0) {
            cout << "NO";
            return 0;
        }
    }

    cout << "YES";
    return 0;
}
