#include <set>
#include <iostream>
#include <vector>
#include <cstddef>

using namespace std;

int main() {
    size_t n;
    size_t k;
    cin >> n >> k;
    std::vector<bool> seats(n);
    std::vector<size_t> ans;
    for (size_t req = 0; req < k; req++) {
        char c;
        cin >> c;
        if (c == '+') {
            size_t l = 0, r = 0;
            size_t max_dst = 0;
            size_t cnt = 0;
            for (size_t i = 0; i < n; i++) {
                if (!seats[i]) {
                    cnt++;
                    size_t cur_dst;
                    if (i + 1 - cnt == 0 || i + 1 == n) {
                        cur_dst = cnt;
                    } else {
                        cur_dst = (cnt + 1) / 2;
                    }
                    if (cur_dst > max_dst) {
                        r = i + 1;
                        l = r - cnt;
                        max_dst = cur_dst;
                    }
                } else {
                    cnt = 0;
                }
            }

            if (l == 0) {
                ans.push_back(1);
            } else if (r == n) {
                ans.push_back(n);
            } else {
                ans.push_back(l + (r - l - 1) / 2 + 1);
            }
            seats[ans.back() - 1] = true;
        } else {
            size_t x;
            cin >> x;
            seats[ans[x - 1] - 1] = false;
        }
    }

    for (auto x: ans) {
        cout << x << endl;
    }

}